/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 
 *-- modified to use the BRWMonitor routines  <------------------------------new
 *-- try to change the interval (milliseconds) to suit your PC speed. ( 250 ? )
 *-- tested with Harbour/miniGUI v.2.6.7
 *--
 *-- As you can see, the basic use in this sample just requires
 *-- 1. #include "BrwMon1.prg"
 *-- 2. Add BRWMonitorBegin() to this sample
 *-- 3. One function you can name it whatever you want with your own code to update
 *--    your secondary database visuals.
 *--    See the sample function at the bottom of this example file.
 *--
	For your text editor, I handle Tabs with 3 spaces.  <------------------------
*/

#include "minigui.ch"
#include "BrwMon1.prg" 	// <-------------------------------------------------new

Function Main

	SET BROWSESYNC ON	

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'MiniGUI Browse Demo) - you can use Right Click too!' ;
		MAIN NOMAXIMIZE ;
		ON INIT { || OpenTables(), BRWMonitorBegin( "Form_1", ; // <-----------new
													{  {"Form_1", "Pedidos", "Pedidos"} , ;
														{"Form_1", "Items", "Items"    }   ;
													} , ;
													"MyFunction", ;
													500 ) ; // <- change INTERVAL to suit PC speed
					} ;
		ON RELEASE CloseTables()

		@ 10,10 LABEL Label_1 VALUE 'Pedidos'

		@ 10,310 LABEL Label_2 VALUE 'Items'

		@ 40,10 BROWSE Pedidos									;
			WIDTH 300  										;
			HEIGHT 350 										;	
			HEADERS { 'Pedido' , 'Cliente' } ;
			WIDTHS { 150 , 150 } ;
			WORKAREA Pedidos ;
			FIELDS { 'Pedidos->Pedido' , 'Pedidos->Cliente' } ;
			ON CHANGE UpdateItems()

		@ 40,310 BROWSE Items									;
			WIDTH 300  										;
			HEIGHT 350 										;	
			HEADERS { 'Pedido' , 'Produto' , 'Quant' , 'Valor' } ;
			WIDTHS { 150 , 150 ,150 , 150 } ;
			WORKAREA Items ;
			FIELDS { 'Items->Pedido' , 'Items->Produto','Items->Quant' , 'Items->Valor' } ;

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return Nil

Procedure OpenTables()

	Use Pedidos New	
	Use Items New

	Form_1.Pedidos.Value := RecNo()
	UpdateItems()
	
Return Nil

Procedure CloseTables()

	Close DataBases

Return Nil

Procedure UpdateItems()

	Select Items
	Set Filter To Items->Pedido = Pedidos->Pedido
	Go Top
	Form_1.Items.Value := RecNo()

Return 



// <-------------------------------------------------------------------------new
Function MyFunction( palBRWList, pacBrwObjectsToMonitor )

	* BRWMonitor timer is paused now, no need to call BRWMonitorTimerPause() here
	
	* palBRWList is an array (a list) with .T./.F. for each browse object monitored
	* pacBrwObjectsToMonitor is the same array you specified in BRWMonitorBegin()
	* and is placed here to facilitate its use, even when normaly you dont need it.

	IF palBRWList[1] = .T. // Pedidos pointer VALUE  not correspond with Recno()
		Pedidos->( dbGoTo( Form_1.Pedidos.VALUE ) )
		UpdateItems()			// update secondary database visuals
	ENDIF
	
	IF palBRWList[2] = .T. // Items pointer VALUE  not correspond with Recno()
		// in this case there isn't a third database visuals to update
	ENDIF

Return .T.  // <-- allways return .T. to resume the BRW monitor process
