/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 
 *-- modified to use the BRWMonitor routines  <------------------------------new
 *-- try to change the interval (milliseconds) to suit your PC speed. ( 250 ? )
 *-- tested with Harbour/miniGUI v.2.6.7
 
          OnChange in PEDIDOS launch updates for ITEMS & CLIENTES
          OnChange in ITEMS   launch updates for PRODUTOS

 *-- Original sample uses the word "Items" to define browse name and DBF alias.
 *-- But in this program I need the command:  Items->(dbGoTo(Form_1.Items.VALUE))
 *-- which results in compiler error, so I change the word "Items" for "xItems"
 *-- 
	For your text editor, I handle Tabs with 3 spaces.  <------------------------
*/

#include "minigui.ch"
#include "BrwMon1.prg" 	// <----------------------------------------------------

Function Main

	SET BROWSESYNC ON	

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'MiniGUI Browse Demo) - you can use Right Click too!' ;
		MAIN NOMAXIMIZE ;
		ON INIT { || OpenTables(), BRWMonitorBegin( "Form_1", ; // <--------------
													{  {"Form_1", "Pedidos", "Pedidos"} , ;
														{"Form_1", "xItems", "xItems"    }   ;
													} , ;
													"MyFunction", ;
													500 ) ; // <- change INTERVAL to suit PC speed
					} ;
		ON RELEASE CloseTables()

		@ 10,10 LABEL Label_1 VALUE 'Pedidos'
		
		@ 180,310 LABEL Label_2 VALUE 'Items'

		@ 40,10 BROWSE Pedidos									;
			WIDTH 185  										;
			HEIGHT 350 										;	
			HEADERS { 'Pedido' , 'Cliente' } ;
			WIDTHS { 100 , 60 } ;
			WORKAREA Pedidos ;
			FIELDS { 'Pedidos->Pedido' , 'Pedidos->Cliente' } ;
			ON CHANGE { || UpdateItems(), UpdateClientes() }

		@ 200,210 BROWSE xItems									;
			WIDTH 410  										;
			HEIGHT 150 										;	
			HEADERS { 'Pedido' , 'Produto' , 'Quant' , 'Valor' } ;
			WIDTHS { 100 , 120 ,60 , 100 } ;
			WORKAREA xItems ;
			FIELDS { 'xItems->Pedido' , 'xItems->Produto','xItems->Quant' , 'xItems->Valor' } ;
			ON CHANGE UpdateProdutos()		// <------------------------

		*--
		@ 040, 210 FRAME Frame_Clientes CAPTION "Cliente" ;
			WIDTH 410 HEIGHT 120 SIZE 12 BOLD

		@ 060, 220 LABEL label_Codigo VALUE "Codigo" SIZE 12 BOLD
			@ 060, 300 LABEL label_Codigodat VALUE "" SIZE 12 BOLD
		
		@ 080, 220 LABEL label_Nome VALUE "Nome" SIZE 12 BOLD
			@ 080, 300 LABEL label_Nomedat VALUE "" SIZE 12 BOLD WIDTH 330
			
		@ 100, 220 LABEL label_Endereco VALUE "Endereco" SIZE 12 BOLD
			@ 100, 300 LABEL label_Enderecodat VALUE "" SIZE 12 BOLD WIDTH 330
			
		@ 120, 220 LABEL label_Cidade VALUE "Cidade" SIZE 12 BOLD
			@ 120, 300 LABEL label_Cidadedat VALUE "" SIZE 12 BOLD WIDTH 330
			
		@ 140, 220 LABEL label_Estado VALUE "Estado" SIZE 12 BOLD
			@ 140, 300 LABEL label_Estadodat VALUE "" SIZE 12 BOLD
			
		*--
		@ 350, 220 LABEL label_Produtonome VALUE "Produto nome" BOLD
			@ 365, 220 LABEL label_Produtonomedat VALUE "" WIDTH 300 BOLD
		*--
		
	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return Nil

Procedure OpenTables()

	*--
	USE CLIENTES NEW
	INDEX ON Codigo TO CLIENTES
	SET INDEX TO CLIENTES
	
	USE PRODUTOS NEW
	INDEX ON Produ_code TO PRODUTOS
	SET INDEX TO PRODUTOS
	*--
	
	Use Pedidos New	
	Use Items ALIAS xItems New

	Form_1.Pedidos.Value := RecNo()
	UpdateItems()
	UpdateClientes()
	
Return Nil

Procedure CloseTables()

	Close DataBases

Return Nil

Procedure UpdateItems()
	
	Select xItems
	Set Filter To xItems->Pedido = Pedidos->Pedido
	Go Top
	Form_1.xItems.Value := RecNo()
	
Return 


Procedure UpdateClientes()
   IF CLIENTES->( dbSeek(Pedidos->Cliente) )

   	Form_1.label_Codigodat.VALUE   := CLIENTES->Codigo
   	Form_1.label_Nomedat.VALUE     := CLIENTES->Nome
   	Form_1.label_Enderecodat.VALUE := CLIENTES->Endereco
   	Form_1.label_Cidadedat.VALUE   := CLIENTES->Cidade
   	Form_1.label_Estadodat.VALUE   := CLIENTES->Estado
   ELSE
   	Form_1.label_Codigodat.VALUE   := ""
   	Form_1.label_Nomedat.VALUE     := "< Cliente NO registrado >"
   	Form_1.label_Enderecodat.VALUE := ""
   	Form_1.label_Cidadedat.VALUE   := ""
   	Form_1.label_Estadodat.VALUE   := ""
   ENDIF
Return

Procedure UpdateProdutos()
	IF PRODUTOS->( dbSeek(xItems->Produto) )
		Form_1.label_Produtonomedat.VALUE := PRODUTOS->Produ_nome
	ELSE
		Form_1.label_Produtonomedat.VALUE := "<Producto no registrado>"
	ENDIF
Return


// <----------------------------------------------------------------------------
Function MyFunction( palBRWList, pacBrwObjectsToMonitor )

	* BRWMonitor timer is paused now, no need to call BRWMonitorTimerPause() here
	
	* palBRWList is an array (a list) with .T./.F. for each browse object monitored
	* pacBrwObjectsToMonitor is the same array you specified in BRWMonitorBegin()
	* and is placed here to facilitate its use, even when normaly you dont need it.

	IF palBRWList[1] = .T. // Pedidos pointer VALUE  not correspond with Recno()
		Pedidos->( dbGoTo( Form_1.Pedidos.VALUE ) )
		UpdateItems()			// update secondary database visuals
		UpdateClientes()
	ENDIF
	
	IF palBRWList[2] = .T. // xItems pointer VALUE  not correspond with Recno()
		xItems->( dbGoTo( Form_1.xItems.VALUE ) )
		UpdateProdutos()
	ENDIF

Return .T.  // <-- allways return .T. to resume the BRW monitor process
